local frame = CreateFrame("Frame", nil, UIParent);

-- This is a comment.

function DoOnSpellCast(self, event, ...)

	local unitID, spell, rank, target = ...;

	local inInstance, instanceType = IsInInstance();
	
	local link = GetSpellLink(spellID);

-- Group Type Stuff

local GetNumRaidMembers = GetNumRaidMembers;
local GetNumPartyMembers = GetNumPartyMembers;
local IsInInstance = IsInInstance;
local InstanceType = "none"

-- 
	tellMessage = 0;


	if (spell == "Hand of Protection") then
		tellMessage = 1;				
		message1 = "Casting " .. GetSpellLink(spell) .. ". " .. target .. " is immune to physical damage for 10 seconds, but can't physically attack.";
	end

	if (spell == "Devotion Aura") then
		tellMessage = 1;
		message1 = "Casting " .. GetSpellLink(spell) .. ". Magic damage to PARTY/RAID reduced by 20% and no silence/interrupt for 6 seconds.";
	end	
	
	if (spell == "Hand of Purity") then
		tellMessage = 1;
		message1 = "Casting " .. GetSpellLink(spell) .. " on " .. target .. ". This will reduce DoTs by 70% for 6 sec.";
	end

	if (spell == "Hand of Freedom") then
		tellMessage = 1;
		message1 = "Casting " .. GetSpellLink(spell) .. ". " .. target .. " is immune to movement impairment.";
	end

	if (spell == "Hand of Salvation") then
		tellMessage = 1;
		message1 = "Casting " .. GetSpellLink(spell) .. " to reduce " .. target .. "'s agro.", "RAID";
	end

	if (spell == "Hand of Sacrifice") then
		tellMessage = 1;
		message1 = "Casting " .. GetSpellLink(spell) .. " to transfer damage to me from " .. target .. ".", "RAID";
	end



	if (tellMessage == 1) then

-- What kind of Group?
	
-- 	SendChatMessage ("num in group is".. GetNumGroupMembers(), SAY);

		if (GetNumGroupMembers() > 0) then

			msgType = "PARTY";

                	if (InstanceType == "pvp") then
                    		msgType = "BATTLEGROUND";
                	elseif ((IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE)) and (InstanceType == "party" or InstanceType == "raid" or InstanceType == "scenario")) then -- Dungeon/Raid Finder
                    		msgType = "INSTANCE_CHAT";
                	elseif (IsInRaid(LE_PARTY_CATEGORY_HOME)) then

                    		msgType = "RAID";
                	end
		else
        		msgType = "SAY";
            	end


	SendChatMessage(message1, msgType);
	tellMessage = 0;
	end

end

frame:RegisterEvent("UNIT_SPELLCAST_SENT");

frame:SetScript("OnEvent", DoOnSpellCast);
